-- GuarmAssist --

--[[
TODO:

PROBLEMS:
update current playerRow (might not update breath)
--]]

local ENCOUNTERID_Guarm = 1962 --Guarm

local MARKER_INTERVAL = 2 --in seconds

local SPELLID_BREATH_Red = 228758 --Fiery Phlegm
local SPELLID_BREATH_Blue = 228768 --Salty Spittle
local SPELLID_BREATH_Violet = 228769 --Dark Discharge

local SPELLID_Foam_Red = 228744 --Flaming Volatile Foam
local SPELLID_Foam_Blue = 228810 --Briney Volatile Foam
local SPELLID_Foam_Violet = 228818 --Shadowy Volatile Foam

local spellIds_Breath = {SPELLID_BREATH_Red, SPELLID_BREATH_Blue, SPELLID_BREATH_Violet};
local spellIds_Colors_Breath = {
  [SPELLID_BREATH_Red] = {1, 0, 0, 1};
  [SPELLID_BREATH_Blue] = {0, 0, 1, 1};
  [SPELLID_BREATH_Violet] = {1, 0, 1, 1};
};
local spellIds_Colors_Foam = {
  [SPELLID_Foam_Red] = {1, 0, 0, 1};
  [SPELLID_Foam_Blue] = {0, 0, 1, 1};
  [SPELLID_Foam_Violet] = {1, 0, 1, 1};
};
local spellIds_Markers_Foam = {
  [SPELLID_Foam_Red] = 7;
  [SPELLID_Foam_Blue] = 6;
  [SPELLID_Foam_Violet] = 3;
};

local LGIST = LibStub:GetLibrary("LibGroupInSpecT-1.1")

local DefaultO = {
  ["blnShowFrame"] = 1;
  ["framePoint"] = "CENTER";
  ["frameRelativeTo"] = "UIParent";
  ["frameRelativePoint"] = "CENTER";
  ["frameOffsetX"] = 0;
  ["frameOffsetY"] = 0;
}

--split string containing quoted and not quoted arguments
--input pattern: (\S+|".+")?(\s+(\S+|".+"))*
--example input: [[arg1 "arg2part1 arg2part2" arg3]]
--example output: {"arg1", "arg2part1 arg2part2", "arg3"}
local function mysplit2(inputstr)
  local i, i1, i2, l, ret, retI = 1, 0, 0, inputstr:len(), {}, 1
  --remove leading spaces
  i1, i2 = inputstr:find("^%s+")
  if i1 then
    i = i2 + 1
  end
  
  while i <= l do
    --find end of current arg
    if (inputstr:sub(i, i)) == "\"" then
      --quoted arg, find end quote
      i1, i2 = inputstr:find("\"%s+", i + 1)
      if i1 then
        --spaces after end quote, more args to follow
        ret[retI] = inputstr:sub(i + 1, i1 - 1)
        retI = retI + 1
        i = i2 + 1
      else
        i1, i2 = inputstr:find("\"$", i + 1)
        if i1 then
          --end of msg
          ret[retI] = inputstr:sub(i + 1, i1 - 1)
          return ret
        else
          -- no end quote found, or end quote followed by no-space-charater found, disregard last arg
          return ret
        end
      end
    else
      --not quoted arg, find next space (if any)
      i1, i2 = inputstr:find("%s+", i + 1)
      if i1 then
        --spaces after arg, more args to follow
        ret[retI] = inputstr:sub(i, i1 - 1)
        retI = retI + 1
        i = i2 + 1
      else
        --end of msg
        ret[retI] = inputstr:sub(i)
        return ret
      end
    end
  end
  return ret
end

local updateOptionsArray, cloneTable, copyValues
--from "SCT" by "Grayhoof"
cloneTable = function(t) -- return a copy of the table t
  local new = {}; -- create a new table
  local i, v = next(t, nil); -- i is an index of t, v = t[i]
  while i do
    if type(v)=="table" then
      v=cloneTable(v);
    end
    new[i] = v;
    i, v = next(t, i); -- get next index
  end
  return new;
end
copyValues = function(from,to)
  local i, v = next(from, nil); -- i is an index of from, v = from[i]
  while i do
    if type(v)=="table" then
      if to[i] ~= nil then
        if type(to[i])=="table" then
          copyValues(v,to[i]);
        end
      end
    else
      if to[i] ~= nil then
        if type(to[i])~="table" then
          to[i] = v;
        end
      end
    end
    i, v = next(from, i); -- get next index
  end
end
updateOptionsArray = function()
  --copy default keys
  local TempGuarmAssistOptions = cloneTable(DefaultO)
  copyValues(GuarmAssistOptions, TempGuarmAssistOptions)
  
  --copy back to savedvar
  GuarmAssistOptions = TempGuarmAssistOptions
end

local frame = CreateFrame("Frame", "GuarmAssistFrame", UIParent)
local frameEvents = {};
local spellNames = {};
local currentDebuffPlayers = {};
local moving = false
local myDebuff = 0

local isDebug = false
local function debugLog(...)
  if isDebug then
    print("GuarmAssist", ...)
  end
end
function GuarmAssist_Debug(msg, i)
  if msg == "debug" then
    isDebug = not isDebug
    print("GuarmAssist: debug", isDebug)
  elseif msg == "eid" then
    if type(i) == "number" then
      ENCOUNTERID_Guarm = i
      debugLog("neweid =", ENCOUNTERID_Guarm, EJ_GetEncounterInfo(i))
    end
  elseif msg == "startcombat" then
    frameEvents["ENCOUNTER_START"](frame, ENCOUNTERID_Guarm, "Guarm", 16, 20)
  elseif msg == "endcombat" then
    frameEvents["ENCOUNTER_END"](frame)
  elseif msg == "update" then
    updatePlayerRows()
  end
end

frame.bgtexture = frame:CreateTexture(nil, "OVERLAY")
frame.bgtexture:SetAllPoints(frame)
frame.bgtexture:SetColorTexture(0, 0, 0, 0.8)

frame:SetScript("OnDragStart", function(self) self:StartMoving(); end);
frame:SetScript("OnDragStop", function(self)
  self:StopMovingOrSizing()
  local point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint()
  GuarmAssistOptions["framePoint"] = point or DefaultO["framePoint"]
  GuarmAssistOptions["frameRelativeTo"] = relativeTo or DefaultO["frameRelativeTo"]
  GuarmAssistOptions["frameRelativePoint"] = relativePoint or DefaultO["frameRelativePoint"]
  GuarmAssistOptions["frameOffsetX"] = xOfs or DefaultO["frameOffsetX"]
  GuarmAssistOptions["frameOffsetY"] = yOfs or DefaultO["frameOffsetY"]
end);

frame.playerRows = {};
local function addPlayerRow(i)
  local row = {};
  row.playername = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
  row.playername:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, -(i-1)*20)
  row.playername:SetFont("Fonts\\ARIALN.TTF", 14, "")
  row.playername:SetTextColor(1, 1, 1, 1)
  row.playername:SetText("Player "..i)
  
  row.breath_bgtexture = frame:CreateTexture(nil, "OVERLAY")
  row.breath_bgtexture:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -20, -(i-1)*20)
  row.breath_bgtexture:SetSize(20, 20)
  row.breath_bgtexture:SetColorTexture(1, 0, 0, 1)
  
  row.foam_bgtexture = frame:CreateTexture(nil, "OVERLAY")
  row.foam_bgtexture:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -(i-1)*20)
  row.foam_bgtexture:SetSize(20, 20)
  row.foam_bgtexture:SetColorTexture(1, 0, 1, 1)
  
  row.foamCountdown = frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
  row.foamCountdown:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 0, -(i-1)*20)
  row.foamCountdown:SetSize(20, 20)
  row.foamCountdown:SetFont("Fonts\\ARIALN.TTF", 14, "")
  row.foamCountdown:SetTextColor(1, 1, 1, 1)
  row.foamCountdown:SetText("10")
  
  frame.playerRows[i] = row
end
addPlayerRow(1)
addPlayerRow(2)
addPlayerRow(3)
local function updatePlayerRow(i)
  local row = frame.playerRows[i]
  
  row.playername:SetText(currentDebuffPlayers[i].name)
  
  for spellId = 1, #spellIds_Breath do
    local spellName = UnitDebuff(currentDebuffPlayers[i].lku, spellNames[spellIds_Breath[spellId]])
    if spellName then
      currentDebuffPlayers[i].breath = spellIds_Breath[spellId]
      break
    end
  end
  
  if currentDebuffPlayers[i].breath == 0 then
    row.breath_bgtexture:Hide()
  else
    row.breath_bgtexture:Show()
    row.breath_bgtexture:SetColorTexture(unpack(spellIds_Colors_Breath[currentDebuffPlayers[i].breath]))
  end
  
  row.foam_bgtexture:SetColorTexture(unpack(spellIds_Colors_Foam[currentDebuffPlayers[i].foam]))
  
  row.foamCountdown:SetText(floor(currentDebuffPlayers[i].expirationTime-GetTime()))
  
  row.playername:Show()
  row.foam_bgtexture:Show()
  row.foamCountdown:Show()
end
local function hidePlayerRow(index)
  frame.playerRows[index].playername:Hide()
  frame.playerRows[index].breath_bgtexture:Hide()
  frame.playerRows[index].foam_bgtexture:Hide()
  frame.playerRows[index].foamCountdown:Hide()
end
local function updatePlayerRows(blnSort)
  if blnSort then
    table.sort(currentDebuffPlayers, function(a,b)
        return a.name<b.name
      end)
  end
  for i = 1, 3 do
    if currentDebuffPlayers[i] then
      updatePlayerRow(i)
    else
      hidePlayerRow(i)
    end
  end
end

local function findFreeSpace()
  local i = 1
  while currentDebuffPlayers[i] do
    i = i + 1
  end
  return i
end
local function addDebuffPlayer(guid, lku, foamSpellId)
  debugLog("addDebuffPlayer(", guid, lku, foamSpellId, ")")
  for _, v in pairs(currentDebuffPlayers) do
    if (v.guid == guid) and (v.foam == foamSpellId) then
      debugLog("player already in table, update")
      if lku then
        for i = 1, #spellIds_Breath do
          local spellName = UnitDebuff(lku, spellNames[spellIds_Breath[i]])
          if spellName then
            v.breath = spellIds_Breath[i]
            break
          end
        end
        
        local spellName2, _, _, _, _, _, expTime = UnitDebuff(lku, spellNames[foamSpellId])
        v.expirationTime = expTime
      end
      return
    end
  end
  
  local name, breath, foamexpiration = "Unknown", 0, 0
  
  if lku then
    name = UnitName(lku)
    
    for i = 1, #spellIds_Breath do
      local spellName = UnitDebuff(lku, spellNames[spellIds_Breath[i]])
      if spellName then
        breath = spellIds_Breath[i]
        break
      end
    end
    
    debugLog(UnitDebuff(lku, spellNames[foamSpellId]))
    local spellName2, _, _, _, _, _, expTime = UnitDebuff(lku, spellNames[foamSpellId])
    foamexpiration = expTime or 10 --to be save
    debugLog("foamexpiration =", foamexpiration)
  end
  
  debugLog("add player:", name)
  local index = findFreeSpace()
  currentDebuffPlayers[index] = {name = name, guid = guid, lku = lku, breath = breath, foam = foamSpellId, expirationTime = foamexpiration};
  
  if guid == UnitGUID("player") then
    myDebuff = foamSpellId
    frame.tslU_Marker = frame.interval_Marker
  end
  
  updatePlayerRows(currentDebuffPlayers[1] and currentDebuffPlayers[2] and currentDebuffPlayers[3])
end
local function removeDebuffPlayer(guid, foamSpellId)
  local found, count = false, 0
  for i, v in pairs(currentDebuffPlayers) do
    count = count + 1
    if (not found) and (v.guid == guid) and (v.foam == foamSpellId) then
      debugLog("remove player")
      currentDebuffPlayers[i] = nil
      found = true
    end
  end
  
  if found then
    if count > 3 then
      --findFreeSpace()
      debugLog("TODO: re-order")
    end
    updatePlayerRows()
  else
    debugLog("player not in table")
  end
  
  if guid == UnitGUID("player") then
    myDebuff = 0
    --frame.tslU_Marker = -1
  end
end
local function removeAllDebuffPlayers()
  for k in pairs(currentDebuffPlayers) do
    currentDebuffPlayers[k] = nil
  end
  
  updatePlayerRows()
  
  myDebuff = 0
  frame.tslU_Marker = -1
end

local function initFrame()
  frame:SetPoint(GuarmAssistOptions["framePoint"], GuarmAssistOptions["frameRelativeTo"], GuarmAssistOptions["frameRelativePoint"], GuarmAssistOptions["frameOffsetX"], GuarmAssistOptions["frameOffsetY"])
  frame:SetFrameStrata("LOW")
  frame:SetSize(150, 60)
  
  frame.toggle = function(self, doNotToggle)
    if not doNotToggle then
      GuarmAssistOptions["blnShowFrame"] = GuarmAssistOptions["blnShowFrame"] == 1 and 0 or 1
    end
    if GuarmAssistOptions["blnShowFrame"] == 1 then
      frame:Show()
    else
      frame:Hide()
    end
  end
  frame:toggle(true)
  
  local spellName = GetSpellInfo(SPELLID_BREATH_Red)
  spellNames[SPELLID_BREATH_Red] = spellName or "Unknown"
  spellName = GetSpellInfo(SPELLID_BREATH_Blue)
  spellNames[SPELLID_BREATH_Blue] = spellName or "Unknown"
  spellName = GetSpellInfo(SPELLID_BREATH_Violet)
  spellNames[SPELLID_BREATH_Violet] = spellName or "Unknown"
  
  spellName = GetSpellInfo(SPELLID_Foam_Red)
  spellNames[SPELLID_Foam_Red] = spellName or "Unknown"
  spellName = GetSpellInfo(SPELLID_Foam_Blue)
  spellNames[SPELLID_Foam_Blue] = spellName or "Unknown"
  spellName = GetSpellInfo(SPELLID_Foam_Violet)
  spellNames[SPELLID_Foam_Violet] = spellName or "Unknown"
  
  frame.tslU = 0 -- -1
  frame.interval = 0.5
  frame.tslU_Marker = -1
  frame.interval_Marker = MARKER_INTERVAL
  
  frame.NoOp = function() end
  frame.RealOnUpdate = function(self, elapsed)
    self.tslU = self.tslU + elapsed
    if self.tslU >= self.interval then
      self.tslU = 0
      
      updatePlayerRows()
    end
    if self.tslU_Marker >= 0 then
      self.tslU_Marker = self.tslU_Marker + elapsed
      if self.tslU_Marker >= self.interval_Marker then
        self.tslU_Marker = 0
        
        if myDebuff > 0 then
          SendChatMessage(format("{rt%d}", spellIds_Markers_Foam[myDebuff]), "SAY")
        end
      end
    end
  end
  frame.OnUpdate = frame.RealOnUpdate --NoOp
  frame:SetScript("OnUpdate", function(self, elapsed)
    self.OnUpdate(self, elapsed)
  end);
  
  frame.startTimer = function(self)
    debugLog("startTimer()")
    self.tslU = 0
    self.OnUpdate = self.RealOnUpdate
  end
end

function frameEvents:ENCOUNTER_START(encounterID, encounterName, difficultyID, raidSize)
  debugLog("ENCOUNTER_START(", encounterID, encounterName, difficultyID, raidSize, ")")
  if (encounterID == ENCOUNTERID_Guarm) and (difficultyID == 16) then --16=mythic, 15=heroic
    debugLog("encounter started!")
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    --self:RegisterEvent("UNIT_AURA")
    
    frame:Show()
  end
end

function frameEvents:ENCOUNTER_END()
  debugLog("encounter ended.")
  self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  --self:UnregisterEvent("UNIT_AURA")
  
  frame:Hide()
  removeAllDebuffPlayers()
end

--[[
function frameEvents:UNIT_AURA(unitID, ...)
  if unitID == "player" then
    debugLog("UNIT_AURA player", ...)
  end
end
--]]

function frameEvents:COMBAT_LOG_EVENT_UNFILTERED(...)
  local _, event, _, _, _, _, _, destGUID = select(1, ...)
  if (event == "SPELL_AURA_APPLIED") or (event == "SPELL_AURA_REFRESH") then
    local spellId = select(12, ...) --from prefix SPELL
    if (spellId == SPELLID_Foam_Red) or (spellId == SPELLID_Foam_Blue) or (spellId == SPELLID_Foam_Violet) then
      local lku = LGIST:GuidToUnit(destGUID)
      if lku then
        debugLog("new debuff on player!")
        addDebuffPlayer(destGUID, lku, spellId)
      end
    end
  elseif event == "SPELL_AURA_REMOVED" then
    local spellId = select(12, ...) --from prefix SPELL
    if (spellId == SPELLID_Foam_Red) or (spellId == SPELLID_Foam_Blue) or (spellId == SPELLID_Foam_Violet) then
      local lku = LGIST:GuidToUnit(destGUID)
      if lku then
        debugLog("debuff removed from player.")
        removeDebuffPlayer(destGUID, spellId)
      end
    end
  end
end

function frameEvents:PLAYER_ENTERING_WORLD(...)
  frame:UnregisterEvent("PLAYER_ENTERING_WORLD")
  
  if not GuarmAssistOptions then
    GuarmAssistOptions = DefaultO
  end
  updateOptionsArray()
  initFrame()
  
  frame:RegisterEvent("ENCOUNTER_START")
  frame:RegisterEvent("ENCOUNTER_END")
end

frame:SetScript("OnEvent", function(self, event, ...)
  frameEvents[event](self, ...)
end);
frame:RegisterEvent("PLAYER_ENTERING_WORLD")

SLASH_GUARMASSIST1 = "/guarm"
SlashCmdList["GUARMASSIST"] = function(msg, editbox)
  local args = mysplit2(msg or "")
  local arg1 = string.lower(args[1] or "")
  
  if arg1 == "move" then
    if moving then
      moving = false
      frame:SetMovable(false) --click-through
      frame:EnableMouse(false)
      frame:RegisterForDrag("")
      frame.bgtexture:SetColorTexture(0, 0, 0, 0.8)
    else
      moving = true
      frame:SetMovable(true);
      frame:EnableMouse(true);
      frame:RegisterForDrag("LeftButton");
      frame.bgtexture:SetColorTexture(0.5, 0.5, 0.5, 0.8)
    end
  elseif arg1 == "reset" then
    GuarmAssistOptions["framePoint"] = DefaultO["framePoint"]
    GuarmAssistOptions["frameRelativeTo"] = DefaultO["frameRelativeTo"]
    GuarmAssistOptions["frameRelativePoint"] = DefaultO["frameRelativePoint"]
    GuarmAssistOptions["frameOffsetX"] = DefaultO["frameOffsetX"]
    GuarmAssistOptions["frameOffsetY"] = DefaultO["frameOffsetY"]
    
    frame:ClearAllPoints()
    frame:SetPoint(GuarmAssistOptions["framePoint"], GuarmAssistOptions["frameRelativeTo"], GuarmAssistOptions["frameRelativePoint"], GuarmAssistOptions["frameOffsetX"], GuarmAssistOptions["frameOffsetY"])
    
    print("|cffaaaaffGuarmAssist |rposition reset")
  elseif arg1 == "toggle" then
    frame:toggle()
    print("|cffaaaaffGuarmAssist is now "..(GuarmAssistOptions["blnShowFrame"] == 1 and "|cffaaffaashown" or "|cffff8888hidden"))
  else
    print("|cffaaaaffGuarmAssist |r"..(GetAddOnMetadata("GuarmAssist", "Version") or "").." |cffaaaaff(use |r/guarm <option> |cffaaaafffor these options)")
    print("  toggle |cffaaaaffshow/hide the frame ("..(GuarmAssistOptions["blnShowFrame"] == 1 and "|cffaaffaashown" or "|cffff8888hidden").."|cffaaaaff)")
    print("  move |cffaaaafftoggle moving the frame ("..(moving and "|cffaaffaamoving" or "|cffff8888fixed").."|cffaaaaff)")
    print("  reset |cffaaaaffreset the frame's position")
  end
end
